## #+TITLE: 
## #+AUTHOR: Emilio Torres Manzanera
## #+DATE: Time-stamp: <2023-11-29 11:12 emilio on emilio-XPS-15-9570>
## #+TAGS: 
## #+PROPERTY: header-args :results output :exports both :session 




cat("
Estoy aproximando una distribución a posteriori por un grid de los valores de theta:
      Supongamos que
            θ sigue una distribución a priori Beta(1,7), y
            La distribución de verosimilitud es una Binomial(X = x; 7, θ).

He aquí la cuestión: ¿cómo trato con esa x?
Hasta donde he llegado, diría que corresponde con los datos que hayamos tomado. Como no tengo datos, me invento unos. Por ejemplo, supongo que (x_1,x_2,x_3,x_4,x_5) siguen una distribución aleatoria de Poisson(λ=1).

Ahora pasemos a R.
A continuación muestro el código que he hecho para simular este experimento.
Suprimo los comentarios aclaratorios, no creo que le sean necesarios. Es un código muy sencillo.

thetas = c(1:10000) / 10000

x = rpois(5, 1)
apriori = dbeta(thetas, 1, 7)
verosimilitud = dbinom(x = x[1], size = 7, prob = thetas)
unstd.posteriori = verosimilitud * apriori
posteriori = unstd.posteriori / sum(verosimilitud*apriori)
# posteriori

for (valor in x[c(2:length(x))]) {
  verosimilitud = dbinom(x = valor, size = 7, prob = thetas)
  unstd.posteriori = verosimilitud * posteriori
  posteriori = unstd.posteriori / sum(verosimilitud*posteriori)
  # posteriori
}

¿He dado en el clavo?
\n")


set.seed(123) # Fijar una semilla para garantizar reproducibilidad
x <- rpois(5, 1) # generamos datos de una distribución Poisson
x # Tiene que ser menor que <=7 (por la binomial)
length(x) # 5 observaciones


## Para theta=0.5 y con 5 observaciones
(l <- dbinom(x , size=7, prob= 0.5))
## la verosimiltud es el producto. <-- ¡que se te olvida esto!
prod(l) # Verosimilitud para theta=0.5
## la apriori en este caso es (logaritmos)
apriori <- dbeta(0.5,1,7)
prod(l)*apriori # numerador

## Pero es mejor trabajar con logaritmos por el tema de la precisión
(logl <- dbinom(x , size=7, prob= 0.5,log=TRUE))
## la verosimiltud sería el producto, que en logaritmos es suma
sum(logl)
## la apriori en este caso es (logaritmos)
apriori <- dbeta(0.5,1,7,log=TRUE)
## y el numerador sería (logaritmos)
sum(logl)+apriori


thetas <- c(1:10000) / 10000 # Mallado de thetas
length(thetas) # 1e4

## Generamos la distribución a priori
apriori <- dbeta(thetas, 1, 7) 
length(apriori)
hist(apriori)


## ============================================================
## Falla por un tema de R, de programación, no que lo hayas  planteado mal
## Aquí es donde R se vuelve un poco tonto
## X mide 5 y theta mide 1e4: el resultado debería medir 5*1e4
verosimilitud <- dbinom(x , size=7, prob= thetas) # Mal
length(verosimilitud) # da 1e4: debería ser 5*1e4
## ============================================================
## hacemos unas pruebas sencillas
(a1 <- dbinom(x , size=7, prob= c(0.5),log=TRUE)) # 5 longitud
(a2 <- dbinom(x , size=7, prob= c(0.8),log=TRUE)) # 5 longitud
length(dbinom(x , size=7, prob= c(0.5,0.8),log=TRUE)) # Maldición, debería salir 10.
## Queremos que salga
(res <- c(sum(a1)+dbeta(0.5,1,7,log=TRUE), sum(a2)+dbeta(0.8,1,7,log=TRUE)) )
## Probamos con formas sencillas
vectorp <- c(0.5,0.8)
res2 <- sapply(vectorp,function(p){ # Para cada valor p=0.5, 0.8
    logl <- sum(dbinom(x , size=7, prob= p,log=TRUE)) # verosimilitud
    apriori <-  dbeta(p,1,7,log=TRUE) # a priori
    logl + apriori
})
all(res==res2) # ¡Bingo! Son iguales


## Lo hacemos para todo el mallado de thetas
numerador <- sapply(thetas,function(p){
    logl <- sum(dbinom(x , size=7, prob= p,log=TRUE)) # verosimilitud
    apriori <-  dbeta(p,1,7,log=TRUE) # a priori
    logl + apriori
})
numeradorenbasenormal <- exp(numerador) # Deshacemos el logaritmo
denominador <- sum(numeradorenbasenormal) # del teorema de Bayes
aposteriori <- numeradorenbasenormal/denominador # Normalizamos para que sumen 1.
hist(aposteriori,prob=TRUE) # Que debería salir una Beta.

